<?php
/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		plugin
* @subpackage	analytics
* @contact 		payplans@readybytes.in
*/
// no direct access
if(!defined('_JEXEC')) die('Restricted access');
class AnalyticsPluginHelper
{
	
	public static function _trackEvent($user_id, $event_name, $args, $is_created = 1)
		{
			
			if($args['email'] == 'not@registered.com' || empty($user_id)){
				return;
			}
			$params =self::getPluginParams('analytics', 'payplans');
			$intercom_is_enabled = $params->get('intercom_is_enabled','');
			$mixpanel_is_enabled = $params->get('mixpanel_is_enabled','');
			$woopra_is_enabled   = $params->get('woopra_is_enabled','');
						
			$prefix 	= "Analytics";
			if($intercom_is_enabled){
				$analytics[] = 'intercom';
				define('ANALYTICS_INTERCOM_APPID',$params->get('intercom_app_id',''));
				define('ANALYTICS_INTERCOM_APPKEY',$params->get('intercom_app_key',''));
			}
			if($mixpanel_is_enabled){
				$analytics[] = 'mixpanel';
				define('ANALYTICS_MIXPANEL_TOKEN',$params->get('mixpanel_token'));
			}  
			
			if($woopra_is_enabled){
				$analytics[] = 'woopra';
			}  
			
			foreach ($analytics as $analytic)
			{
				$className	= $prefix.$analytic;
				require_once(dirname(__DIR__) . DS.'plugins' .DS.strtolower($analytic).DS. strtolower($analytic).'.php');
				$tool 		= new $className();
				try {
					$tool->trackEvent($user_id, $event_name, $args, $is_created);
				}
				catch (Exception $e){
					// Mark Start
					$message = XiText::_('COM_PAYPLANS_ANALYTICS_PLUGIN_NOT_WORKING');
					$content = array('Message'=>$message);
					PayplansHelperLogger::log(XiLogger::LEVEL_ERROR, $message, null, $content);
				}
			}
			
		}
		
	public static function getPluginParams($pluginName, $pluginType)
		{
			$plugin = JPluginHelper::getPlugin($pluginType, $pluginName);
			$params = new JRegistry($plugin->params);
			return $params;
		}


	// subscriptions
	public static function _getDetailSubscription(PayplansSubscription $sub)
	{
		$ret = array();
		$plan_id				= $sub->getPlans();
		$ret['sub_plan_id']		= array_pop($plan_id);
		$ret['sub_plan_name']	= $sub->getTitle();
	
		return $ret;
	}
	
	//To Find Details When an Invoice Gets Paid
	public static function _getDetailInvoice(PayplansInvoice $invoice)
	{
		$ret = array();
	
		$order = $invoice->getReferenceObject(true);
		$plan_id				= $order->getPlans();
		$ret['sub_plan_id']    	= array_pop($plan_id);
		$ret['sub_plan_name']  	= $invoice->getTitle();
		$ret['sub_revenue']   	= $invoice->getTotal();
		$ret['sub_discount']  	= $invoice->getDiscount();
		$ret['sub_inv_status']  = $invoice->getStatusName();
	
		return $ret;
	}
	
	public static function _getUserId($email_or_username){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true)
					->select('id')
					->from($db->quoteName('#__users'))
					->where($db->quoteName('username') . ' = ' . $db->quote($email_or_username) .' OR '.$db->quotename('email'). '=' .$db->quote($email_or_username));
		// Get the email
		$db->setQuery($query);
		return $user = $db->loadObject();
	}
	
}
